#pragma once 

#define MPI_CALL(call) \
{ \
            int mpierr = call; \
            if (mpierr != 0) \
        { \
            char errstr[1024]; \
            int len = 0, rank = 0; \
            if (len >= 1024) \
            MPI_Error_string(mpierr, errstr, &len); \
            if (len >= 1024) \
                errstr[1023] = 0; \
                fprintf(stderr, "%s:%d rank=%i %s\n", __FILE__, \
                                                      __LINE__, MPI_Comm_rank(MPI_COMM_WORLD, &rank), errstr); \
                        throw std::runtime_error("MPI function call returned error state"); \
                } \
} 

